/**
 * Este software pertenece a Cajamar Caja Rural Sociedad Cooperativa de Crdito. Se prohbe todo uso
 * y/o explotacin del software que no cuente con la autorizacin expresa por escrito de Cajamar
 * Caja Rural Sociedad Cooperativa de Crdito. Todos los derechos se encuentran reservados.
 */

package zk.test;

import org.apache.log4j.Logger;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zk.ui.event.SelectEvent;
import org.zkoss.zul.Tree;

/**
 * @author dmg60561
 */
public class EgiptoSelectEventListener implements EventListener<SelectEvent> {

    /** El arbol que gestiona este tree */
    private Tree tree;

    /**
     * Constructor para el paquete.
     * 
     * @param t
     *            arbol que gestiona este eventlistener.
     */
    EgiptoSelectEventListener(final Tree t) {
        tree = t;
    }

    /*
     * (non-Javadoc)
     * @see org.zkoss.zk.ui.event.EventListener#onEvent(org.zkoss.zk.ui.event.Event)
     */
    @Override
    public void onEvent(final SelectEvent event) throws Exception {
        Logger logger = Logger.getLogger(getClass().getName());
        Component comp = event.getReference();
        logger.info("" + comp.getClass().getName() + " " + comp.getId());
        Component target = event.getTarget();
        logger.info("" + target.getClass().getName() + " " + target.getId());
        logger.info("" + event.getPreviousSelectedItems().contains(comp) + " "
                + event.getSelectedItems().contains(comp));
        logger.info("" + event.getPreviousSelectedItems().contains(target) + " "
                + event.getSelectedItems().contains(target));
    }

}
