/**
 * Este software pertenece a Cajamar Caja Rural Sociedad Cooperativa de Crdito. Se prohbe todo uso
 * y/o explotacin del software que no cuente con la autorizacin expresa por escrito de Cajamar
 * Caja Rural Sociedad Cooperativa de Crdito. Todos los derechos se encuentran reservados.
 */

package zk.test;

import java.util.Set;

import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.Events;
import org.zkoss.zk.ui.util.Clients;
import org.zkoss.zk.ui.util.GenericForwardComposer;
import org.zkoss.zul.Button;
import org.zkoss.zul.DefaultTreeModel;
import org.zkoss.zul.Label;
import org.zkoss.zul.Textbox;
import org.zkoss.zul.Tree;
import org.zkoss.zul.TreeNode;
import org.zkoss.zul.Vlayout;
import org.zkoss.zul.Window;
import org.zkoss.zul.event.TreeDataListener;

/**
 * @author fcf60478
 */
public final class UpdateController extends GenericForwardComposer<Window> {

    /**
     * Indica la tarea a la que se aade un conjunto de elementos cuando se hace un import masivo.
     */
    Textbox txtTask;

    /** serialVersionUID */
    private static final long serialVersionUID = 1L;


    /**
     * Panel de modificacion de elementos
     */
    Vlayout pnUpdate;

    /**
     * Referencia al objeto Tree de la pantalla
     */
    Tree treeEgipto;


    /** Indicador de elementos seleccionados en el rbol de egipyo */
    Label selectedCount;


    /**
     * Boton de consultar/modificar
     */
    Button btOk;
    Button upload;


    /**
     * Referencia al modelo de datos del Tree de la pantalla
     */
    private DefaultTreeModel<EgiptoElement> treeModel = null;

    /**
     * Referencia a treeDataListener
     */
    private transient TreeDataListener treeDataListener = null;

    /**
     * Devuelve un listener de cambio de datos
     * 
     * @return un objeto de tipo TreeDataListener
     */
    private TreeDataListener getTreedataListener() {
        if (treeDataListener == null) {
            treeDataListener = new EgiptoElementSelectTreeDataListener(treeEgipto, selectedCount);
        }
        return treeDataListener;
    }

    /**
     * Devuelve el modelo de datos del tree
     * 
     * @return Objecto de tipo DefaultTreeModel
     */
    private DefaultTreeModel<EgiptoElement> getTreeModel() {
        if (treeModel == null) {
            treeModel = UtilsPkg.newTreeModelEgipto();
        }
        return treeModel;
    }

    /**
     * Evento que se lanza cuando se crea la ventana updatepkg.zul
     * 
     * @param event
     *            El evento que eleva zk.
     */
    public void onCreate$updatepkg(final Event event) {
        self.setTitle("Updating");
        //initTree();
        //upload.setDisabled(false);
    }

    /**
     * Clieck on OK event
     */
    public void onClick$btOk(Event event) {
        initTree();
        pnUpdate.setVisible(true);
        upload.setDisabled(false);
    }

    /**
     * inicializa el treeEgipto
     * 
     * @return null si no hay error, en caso contrario el mensaje de error
     */
    private String initTree() {
        String msg = null;
        getTreeModel().addTreeDataListener(getTreedataListener());//6
        treeEgipto.setModel(getTreeModel()); //1
        UtilsPkg.loadTreeModelegipto(getTreeModel(), "UNUSEFUL"); //2

        treeEgipto.setItemRenderer(new EgiptoElementTreeitemRenderer());//5
        treeEgipto.setMultiple(true);//3
        treeEgipto.setCheckmark(true);//4
        
        return msg;
    }

    /**
     * Accion onDoubleClick
     * 
     * @param e
     *            El evento
     */
    public void onDoubleClick$lbPkg(final Event e) {
        onClick$btOk(e);
    }

    /**
     * @param event
     *            El evento que eleve zk.
     */
    public void onClick$btDependency(Event event) {
        Clients.showBusy("Procesando dependencias ...");
        Events.echoEvent("onProcessRequest", self, "dependencies");
    }

    /**
     * Manejador de eventos de seleccion del Tree. Es obligatoria su definicion para que funcione la
     * seleccion multiple.
     * 
     * @param event
     *            El evento que eleve zk.
     */
    public void onSelect$treeEgipto(final Event event) {
        // No borrar, es necesario para que funcione la seleccion multiple
        int count = 0;
        DefaultTreeModel model = (DefaultTreeModel) treeEgipto.getModel();
        Set<?> sels = model.getSelection();
        for (Object o : sels) {
            if (o instanceof TreeNode<?>) {
                TreeNode<?> t = (TreeNode<?>) o;
                if (t.isLeaf()) {
                    count++;
                }
            }
        }
        selectedCount.setValue(count + " elementos seleccionados");
    }

}
