/**
 * Este software pertenece a Cajamar Caja Rural Sociedad Cooperativa de Crdito. Se prohbe todo uso
 * y/o explotacin del software que no cuente con la autorizacin expresa por escrito de Cajamar
 * Caja Rural Sociedad Cooperativa de Crdito. Todos los derechos se encuentran reservados.
 */

package zk.test;

import java.util.logging.Logger;

import org.zkoss.zul.DefaultTreeModel;
import org.zkoss.zul.DefaultTreeNode;


/**
 * @author fcf60478
 */
public final class UtilsPkg {
    /** Logger de esta clase */
    private static Logger log = Logger.getLogger(UtilsPkg.class.getName());

    /**
     * Constructor por defecto
     */
    private UtilsPkg() {

    }

    /**
     * @param treeModel
     *            Referencia al modelo de datos del arbol
     * @param projectId
     *            Id de proyecto
     * @throws EgiptoConnectorException
     *             Posibles errores
     */
    public static void loadTreeModelegipto(DefaultTreeModel<EgiptoElement> treeModel,
            String projectId) {
        long t0 = System.currentTimeMillis();
        DefaultTreeNode<EgiptoElement> root =
                (DefaultTreeNode<EgiptoElement>) treeModel.getRoot();
        EgiptoElement treeProject = getTreeProject();
        long t1 = System.currentTimeMillis();
        log.severe("Obtenido arbol del proyecto en " + (t1 - t0) + " milisegundos");
        root.setData(treeProject);
        // Procesa el arbol de nodos
        setTreeNodesFor(root);
        long t2 = System.currentTimeMillis();
        log.severe("Renderizado arbol en  " + (t2 - t1) + " milisegundos");
    }

    /**
     * @param root
     */
    private static void setTreeNodesFor(DefaultTreeNode<EgiptoElement> node) {
        EgiptoElement ee = node.getData();
        Logger logger = Logger.getLogger(UtilsPkg.class.getName());
        if (ee.getChildren().size() > 0) {
            node.getModel().addOpenObject(node);
        }

        for (int i = 0; i < ee.getChildren().size(); i++) {
            DefaultTreeNode<EgiptoElement> dtn = null;
            if (hasSoftwareElements(ee.getChildren().get(i))) {
                dtn = new DefaultTreeNode<EgiptoElement>(ee.getChildren().get(i), null, false);
                logger.info("Aadiendo a " + ee.getName() + " "
                        + ee.getChildren().get(i).getName());
                node.add(dtn);
            } else {
                dtn = new DefaultTreeNode<EgiptoElement>(ee.getChildren().get(i));
                logger.info("Aadiendo a " + ee.getName() + " "
                        + ee.getChildren().get(i).getName());
                node.add(dtn);
            }
            if (dtn != null) {
                setTreeNodesFor(dtn);
            }
        }
    }

    /**
     * @return
     */
    private static zk.test.EgiptoElement getTreeProject() {
        EgiptoElement root = new EgiptoElement();
        root.name = "root";
        root.desc = "descrip";
        EgiptoElement node1 = new EgiptoElement();
        root.children.add(node1);
        node1.name = "node1";
        node1.desc = "node1ffffffff";
        EgiptoElement node12 = new EgiptoElement();
        node1.children.add(node12);
        node12.name = "node12";
        node12.desc = "node12 fffffffffff";
        EgiptoElement node2 = new EgiptoElement();
        root.children.add(node2);
        node2.name = "node2";
        node2.desc = "node2 ffffffffffffffffff";
        EgiptoElement node21 = new EgiptoElement();
        node2.children.add(node21);
        node21.name = "node21";
        node21.desc = "node21    vvv      ";
        EgiptoElement node22 = new EgiptoElement();
        node2.children.add(node22);
        node22.name = "node22";
        node22.desc = "node22 vvvvvvvvvvvvvvv";
        return root;
    }

    /**
     * @return Crea un modelo de datos
     */
    public static DefaultTreeModel<EgiptoElement> newTreeModelEgipto() {
        return new DefaultTreeModel<EgiptoElement>(new DefaultTreeNode<EgiptoElement>(null, null,
                false));
    }

    /**
     * @param egiptoElement
     *            Un elemento de Egipto
     * @return true si el elemento existe, false en caso contrario
     */
    private static boolean hasSoftwareElements(final EgiptoElement egiptoElement) {
        return !egiptoElement.getChildren().isEmpty();
    }

}
